#!/bin/bash

if [ "-h" = "$1" ]; then
   echo ""
   echo "    -h Displays this help"
   echo "    -c Compiles Code";
   echo ""
   echo "    To Compile & Run (Needs for the first time) execute command: ./run.sh -c"
   echo "    To Run Execute command: ./run.sh "
   exit;
fi

if [ "-c" = "$1" ]; then
echo "Cleaning...";
\rm -rf ./classes
mkdir -p ./classes

echo "Compiling...";
javac -d ./classes -classpath ./lib/*:./classes/*: ./com/strongmail/restclient/*.java ./com/strongmail/restclient/samples/*.java
fi

echo "Running Samples...";
java \
   -classpath \
   "$(echo \
         $PWD/lib/*.jar \
         $PWD/classes | sed -e 's/ /:/g'
      )" \
   com/strongmail/restclient/samples/RestSamples

