/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2013 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */

package com.strongmail.webserviceclient.samples.cxf;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.xml.bind.DatatypeConverter;


/**
 * Adapter for mapping xs:date and xs:dateTime to java.util.Date instead of XMLGregorianCalendar.
 * This class should be kept identical (with the exception of the package declaration) to its
 * identically-named counterpart on the other side of the server<->client relationship.
 */
public class DateAdapter
{
  public static Date parseDate(String s)
  {
    return DatatypeConverter.parseDate(s).getTime();
  }

  public static String printDate(Date d)
  {
    Calendar cal = new GregorianCalendar();

    cal.setTime(d);
    return DatatypeConverter.printDate(cal);
  }

  public static Date parseDateTime(String s)
  {
    return DatatypeConverter.parseDateTime(s).getTime();
  }

  public static String printDateTime(Date d)
  {
    Calendar cal = new GregorianCalendar();

    cal.setTime(d);
    return DatatypeConverter.printDateTime(cal);
  }

  public static Date parseTime(String s)
  {
    return DatatypeConverter.parseTime(s).getTime();
  }

  public static String printTime(Date d)
  {
    Calendar cal = new GregorianCalendar();

    cal.setTime(d);
    return DatatypeConverter.printTime(cal);
  }
}
