#!/bin/bash

if [ "-h" = "$1" ]; then
   echo ""
   echo "    -h Displays this help"
   echo "    -g Generate CXF client"
   echo "    -c Compiles Code";
   echo ""
   echo "    To Generate,Compile & Run (Needs for the first time) execute command: ./run.sh -g -c"
   echo "    To Run Execute command: ./run.sh "
   exit;
fi

HOSTNAME=`hostname`
PWD=`pwd`
if [ "-g" = "$1" ]; then

echo "Generate stub code from WSDL/XSD";
java -classpath ./lib/*: org.apache.cxf.tools.wsdlto.WSDLToJava -b ./bindingClient.xjb -d . -p http://www.strongmail.com/services/2009/03/02=com.strongmail.webserviceclient.samples.cxf.generated -p http://www.strongmail.com/services/2009/03/02/schema=com.strongmail.webserviceclient.samples.cxf.generated.objects -p http://www.w3.org/2001/XMLSchema=com.strongmail.webserviceclient.samples.cxf.generated.objects.xmlschema -quiet -sn MailingService  -validate -wv 1.1 ../MailingService.wsdl
fi

if [ "-c" = "$2" ]; then

echo "Creating directory";
mkdir -p ./classes
echo "Compile generated and sample code";
javac -d ./classes -classpath ./lib/*:./classes/*: com/strongmail/webserviceclient/samples/cxf/*.java com/strongmail/webserviceclient/samples/cxf/generated/*.java com/strongmail/webserviceclient/samples/cxf/generated/objects/*.java
fi

echo "Run sample code";
java \
   -Djavax.net.ssl.trustStore=./.ms_client_keystore \
   -Djavax.net.ssl.trustStorePassword=changeit  \
   -Dendpoint.address=https://$HOSTNAME:4443/sm/services/mailing/2009/03/02  \
   -Dwsdl=../MailingService.wsdl  \
   -Dservices.namespace=http://www.strongmail.com/services/2009/03/02  \
   -Dservices.namespace.schema=http://www.strongmail.com/services/2009/03/02/schema \
   -classpath \
   "$(echo \
         $PWD/lib/FastInfoset-1.2.2.jar \
         $PWD/lib/XmlSchema-1.4.2.jar \
         $PWD/lib/aopalliance-1.0.jar \
         $PWD/lib/commons-collections-3.2.1.jar \
         $PWD/lib/commons-io-2.0.1.jar \
         $PWD/lib/commons-lang-2.1.jar \
         $PWD/lib/commons-lang-2.5.jar \
         $PWD/lib/commons-logging-1.0.4.jar \
         $PWD/lib/cxf-2.1.3-patch.jar \
         $PWD/lib/cxf-2.1.3.jar \
         $PWD/lib/jaxb-impl.jar \
         $PWD/lib/jaxb-xjc.jar \
         $PWD/lib/jaxws-rt.jar \
         $PWD/lib/jetty-6.1.9.jar \
         $PWD/lib/jetty-util-6.1.9.jar \
         $PWD/lib/jra-1.0-alpha-4.jar \
         $PWD/lib/junit-4.1.jar \
         $PWD/lib/log4j-1.2.14.jar \
         $PWD/lib/mail-1.4.4.jar \
         $PWD/lib/neethi-2.0.4.jar \
         $PWD/lib/opensaml-1.1.jar \
         $PWD/lib/ostermillerutils_1_06_01.jar \
         $PWD/lib/postgresql-9.1-902.jdbc4.jar \
         $PWD/lib/serializer-2.7.1.jar \
         $PWD/lib/velocity-1.5.jar \
         $PWD/lib/wsdl4j-1.6.2.jar \
         $PWD/lib/wss4j-1.5.4.jar \
         $PWD/lib/wstx-asl-3.2.6.jar \
         $PWD/lib/xml-resolver-1.2.jar \
         $PWD/lib/xmlsec-1.4.0.jar \
         $PWD/classes | sed -e 's/ /:/g'
      )" \
   com.strongmail.webserviceclient.samples.cxf.ProgramSample \
   $(date +%Y%m%d%H%M%S) true \

