<?php
/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2011 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


require_once "SampleHelper.php";
require_once "./generated/MailingService.php";

class StrongtoolSample
{
  private $service;
  private $helper;

  public function __construct($service)
  {
    $this->service = $service;
    $this->helper = new SampleHelper($service);
  }

  public function createStrongtool($name)
  {
    $strongtool = new Strongtool();

    $strongtool->name = $name;
    $strongtool->url = "http://www.strongmail.com";
    $strongtool->openAs = "NEW_BROWSER";

    $orgId = new OrganizationId();
    $orgId->id = "1";
    $strongtool->organizationId = $orgId;

    $request = SampleHelper::getSoapCreateRequestObject($strongtool, "Strongtool");
    $response = $this->service->create($request);

    return $response->createResponse[0]->objectId;
  }

  /**
   * Get and print strongtool object to standard out.
   *
   * @param strongtoolId the strongtool ID that will be retrieved and printed.
   * @throws Exception any exception
   */
  public function getAndPrint($strongtoolId)
  {
    $strongtools = $this->helper->get(array(SampleHelper::getSoapEntityIdObject(new StrongtoolId(),
										$strongtoolId->id,
										"StrongtoolId")));
    $strongtool = $strongtools[0];

    // Print strongtool to standard out
    print("\nStrongtool:" . "\n");
    print("StrongtoolId: " . $strongtool->objectId->id . "\n");
    print("Name: " . $strongtool->name . "\n");
    print("URL: " . $strongtool->url . "\n");
    print("Open Type: " . $strongtool->openAs . "\n");
    print("Organization ID: " . $strongtool->organizationId->id . "\n");
  }
}
?>
