<?php
/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2011 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


require_once "SampleHelper.php";
require_once "./generated/MailingService.php";

class UserSample
{
  private $service;
  private $helper;

  public function __construct($service)
  {
    $this->service = $service;
    $this->helper = new SampleHelper($service);
  }

  public function createUser($userLogin)
  {
    $user = new User();

    $user->firstName = "PHP-Sample";
    $user->lastName = "User";
    $user->email = "superuser@phpsample.com";
    $user->login = $userLogin;
    $user->password = "SuperUser!123";
    $user->isSuperUser = false;
    $user->isAdmin = false;

    $orgId = new OrganizationId();
    $orgId->id = "1";
    $user->organizationId = $orgId;

    $request = SampleHelper::getSoapCreateRequestObject($user, "User");
    $response = $this->service->create($request);

    return $response->createResponse[0]->objectId;
  }

  /**
   * Get and print user object to standard out.
   *
   * @param userId the user ID that will be retrieved and printed.
   * @throws Exception any exception
   */
  public function getAndPrint($userId)
  {
    $users = $this->helper->get(array(SampleHelper::getSoapEntityIdObject(new UserId(),
										$userId->id,
										"UserId")));
    $user = $users[0];

    // Print target to standard out
    print("\nUser:" . "\n");
    print("UserId: " . $user->objectId->id . "\n");
    print("First Name: " . $user->firstName . "\n");
    print("Last Name: " . $user->lastName . "\n");
    print("Email: " . $user->email . "\n");
    print("Login: " . $user->login . "\n");
    print("Organization ID: " . $user->organizationId->id . "\n");
  }
}
?>
