# Copyright 2008, 2009, StrongMail Systems, Inc.  All rights reserved.

require 'SampleHelper'

class ContentBlockSample
  def initialize(svc)
    @svc = svc
  end


  # Create a content block.
  #  contentBlockName is the name of the content block.
  #  dataFile is the file contains the content block.
  def createContentBlock(contentBlockName, dataFile)
    contentBlock = ContentBlock.new
    contentBlock.name = contentBlockName
    contentBlock.description = "ContentBlock from Ruby"
    
    # Read content from a file
    contentBlock.content = File.open(dataFile, "r") {|io| io.read}

    return SampleHelper::create(@svc, contentBlock)
  end


  # Get and print out a content block.
  #  contentBlockId is the content block ID whose content will be print out.
  def getAndPrint(contentBlockId)
    contentBlock = SampleHelper::get(@svc, contentBlockId)
    puts contentBlock.class
    puts "\tID: " + contentBlock.objectId.id
    puts "\tName: " + contentBlock.name
    puts "\tCreated Time: " + contentBlock.createdTime.to_s()
    puts "\tDescription: " + contentBlock.description
    puts "\tModified Time: " + contentBlock.modifiedTime.to_s()
    puts "\tOrganization: " + contentBlock.organizationId.id
    puts "\tUserId: " + contentBlock.ownerId.id
    puts "\tSize: " + contentBlock.size.to_s()
  end

end
