/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2013 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */

package com.strongmail.webserviceclient.samples.cxf;

import org.apache.ws.security.WSPasswordCallback;

import java.io.IOException;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;


/**
 * This file set call back password.
 */
public class ClientPasswordCallbackHandler implements CallbackHandler
{
  private String password;

  public ClientPasswordCallbackHandler(String password)
  {
    this.password = password;
  }

  public void handle(Callback[] callbacks)
    throws IOException, UnsupportedCallbackException
  {
    WSPasswordCallback pc = (WSPasswordCallback)callbacks[0];
    pc.setPassword(password);
  }
}
