﻿/* Copyright 2008, 2009, StrongMail Systems, Inc.  All rights reserved. */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;


namespace ConsoleApplication1
{
    class ContentBlockSample
    {
        private MailingService service;
        private SampleHelper helper;

        public ContentBlockSample(MailingService service)
        {
            this.service = service;
            this.helper = new SampleHelper(service);
        }


        /* Create a content block.
         * 
         * contentBlockName is the name of the content block.
         * dataFile is the file contains the content block.
         */
        public ContentBlockId createContentBlock(String contentBlockName)
        {
            ContentBlock contentBlock = new ContentBlock();
            contentBlock.description = "ContentBlock from dotnet";
            contentBlock.name = contentBlockName;
            FileStream dataFile= File.OpenRead(SampleProgram.CONTENT_BLOCK_FILE);

            // Read content from a file
            TextReader reader = new StreamReader(dataFile);
            contentBlock.content = reader.ReadToEnd();
            ContentBlockId cbId = (ContentBlockId)helper.create(contentBlock);
            dataFile.Close();
            return cbId;
        }


        /* Get and print out a content block.
         * 
         * contentBlockId is the content block ID whose content will be print out.
         */
        public void getAndPrint(ContentBlockId contentBlockId)
        {
            ContentBlock contentBlock = (ContentBlock) helper.get(contentBlockId);
            Console.WriteLine("\nContentBlock:");
            Console.WriteLine("\tID: " + contentBlock.objectId.id); 
            Console.WriteLine("\tName: " + contentBlock.name);
            Console.WriteLine("\tCampaign: " + contentBlock.campaignId);
            Console.WriteLine("\tCreatedTime: " + contentBlock.createdTime);
            Console.WriteLine("\tDescription: " + contentBlock.description);
            Console.WriteLine("\tModifiedTime: " + contentBlock.modifiedTime);
            Console.WriteLine("\tOrganization: " + contentBlock.organizationId.id);
            Console.WriteLine("\tOwenr: " + contentBlock.ownerId.id);
            Console.WriteLine("\tSize: " + contentBlock.size);
        }

    }
}