﻿/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2014 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace ConsoleApplication1
{
    class TagSample
    {
        private MailingService service;
        private SampleHelper helper;

        public TagSample(MailingService service)
        {
            this.service = service;
            this.helper = new SampleHelper(service);
        }


        /* Create a tag
         * 
         * tagName is the name of tag
         * 
         * return the ID of created tag.
         */
        public TagId createTag(string tagName)
        {
            Tag tag = new Tag();
            tag.name = tagName;
            tag.description = "Created using .net samples";
            tag.createdTimeSpecified = false;
            tag.modifiedTimeSpecified = false;

            TagValue tagValue1 = new TagValue();
            tagValue1.value = "demovalue-1";            

            TagValue tagValue2 = new TagValue();
            tagValue2.value = "demovalue2";

            TagValue tagValue3 = new TagValue();
            tagValue3.value = "demovalue-3";

            tag.tagValue = new TagValue[] { tagValue1, tagValue2, tagValue3 };

            TagId tagId = (TagId)helper.create(tag);
            getAndPrint(tagId);

            return tagId;
        }

        private void getAndPrint(TagId tagId)
        {
            Tag tag = (Tag)helper.get(tagId);
            Console.WriteLine("\nTag:");
            Console.WriteLine("\tID: " + tag.objectId.id);
            Console.WriteLine("\tName: " + tag.name);
            Console.WriteLine("\tDescription: " + tag.description);
            Console.WriteLine("\tModifiedTime: " + tag.modifiedTime);
            Console.WriteLine("\tOrganization: " + tag.organizationId.id);
            Console.WriteLine("\tOwner: " + tag.ownerId.id);
            Console.WriteLine("\tValues: ");
            for (int i = 0; i < tag.tagValue.Length; i++)
            {
                Console.WriteLine("\t\t-" + tag.tagValue[i].value);
            }
        }

    }

}
