<?php
/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2015 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


require_once "SampleHelper.php";
require_once "./generated/MailingService.php";

class AssignedRoleSample
{
  private $service;
  private $helper;

  public function __construct($service)
  {
    $this->service = $service;
    $this->helper = new SampleHelper($service);
  }

  public function createAssignedRole($userId, $orgId, $roleId)
  {
    $assignedRole = new AssignedRole();

    $assignedRole->userId = $userId;
    $assignedRole->organizationId = $orgId;
    $assignedRole->roleId = $roleId;

    // Make call
    $response = $this->helper->create($assignedRole);
    return $response->objectId;
  }

  /**
   * Get and print role object to standard out.
   *
   * @param userId the user ID that will be retrieved and printed.
   * @throws Exception any exception
   */
  public function getAndPrint($assignedRoleId)
  {
    $assignedRoles = $this->helper->get(array(SampleHelper::getSoapEntityIdObject(new AssignedRoleId(),
										$assignedRoleId->id,
										"AssignedRoleId")));
    $assignedRole = $assignedRoles[0];

    // Print role to standard out
    print("\nAssignedRole:" . "\n");
    print("AssignedRoleId: " . $assignedRole->objectId->id . "\n");
    print("UserId: " . $assignedRole->userId->id . "\n");
    print("OrganizationId: " . $assignedRole->organizationId->id . "\n");
    print("RoleId: " . $assignedRole->roleId->id . "\n");
  }
}
?>
