<?php
/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2015 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


require_once "SampleHelper.php";
require_once "./generated/MailingService.php";

class MailingClassSample
{
  private $service;
  private $helper;

  public function __construct($service)
  {
    $this->service = $service;
    $this->helper = new SampleHelper($service);
  }

  public function createMailingClass($name, $orgId)
  {
    $mailingClass = new MailingClass();

    $mailingClass->name = $name;

    $mailingClass->organizationId = array();
    $mailingClass->organizationId[] = $orgId;

    // Make call
    $response = $this->helper->create($mailingClass);
    return $response->objectId;
  }

  /**
   * Get and print mailingClass object to standard out.
   *
   * @param mailingClassId the mailingClass ID that will be retrieved and printed.
   * @throws Exception any exception
   */
  public function getAndPrint($mailingClassId)
  {
    $mailingClasss = $this->helper->get(array(SampleHelper::getSoapEntityIdObject(new MailingClassId(),
										$mailingClassId->id,
										"MailingClassId")));
    $mailingClass = $mailingClasss[0];

    // Print mailingClass to standard out
    print("\nMailingClass:" . "\n");
    print("MailingClassId: " . $mailingClass->objectId->id . "\n");
    print("Name: " . $mailingClass->name . "\n");
    print("Organization ID: " . $mailingClass->organizationId[0]->id . "\n");
  }
}
?>
