<?php
/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2015 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


require_once "SampleHelper.php";
require_once "./generated/MailingService.php";

class MediaServerSample
{
  private $service;
  private $helper;

  public function __construct($service)
  {
    $this->service = $service;
    $this->helper = new SampleHelper($service);
  }

  public function createMediaServer($name)
  {
    $mediaServer = new MediaServer();

    $mediaServer->name = $name;
    $mediaServer->defaultUrl = "http://127.0.0.1/img";
    $mediaServer->isWritable = true;

    $orgId = new OrganizationId();
    $orgId->id = "1";
    $mediaServer->organizationId = $orgId;

    $serverConnInfo = new server();
    $serverConnInfo->defaultImagePath = "/data1/strongmail/data/webdocs/";
    $serverConnInfo->host = "127.0.0.1";
    $serverConnInfo->login = "root";
    $serverConnInfo->password = "nayana";
    $serverConnInfo->sshPort = 22;

    $mediaServer->server = array();
    $mediaServer->server[] = $serverConnInfo;

    // Make call
    $response = $this->helper->create($mediaServer);
    return $response->objectId;
  }

  /**
   * Get and print mediaServer object to standard out.
   *
   * @param mediaServerId the mediaServer ID that will be retrieved and printed.
   * @throws Exception any exception
   */
  public function getAndPrint($mediaServerId)
  {
    $mediaServers = $this->helper->get(array(SampleHelper::getSoapEntityIdObject(new MediaServerId(),
										$mediaServerId->id,
										"MediaServerId")));
    $mediaServer = $mediaServers[0];

    // Print mediaServer to standard out
    print("\nMediaServer:" . "\n");
    print("MediaServerId: " . $mediaServer->objectId->id . "\n");
    print("Name: " . $mediaServer->name . "\n");
    print("Default URL: " . $mediaServer->defaultUrl . "\n");
    print("Writable: " . $mediaServer->isWritable . "\n");
    print("Server connection info:" . "\n");
    print("   Default Image Path: " . $mediaServer->server[0]->defaultImagePath . "\n");
    print("   Host: " . $mediaServer->server[0]->host . "\n");
    print("   Login: " . $mediaServer->server[0]->login . "\n");
    print("   SSH Port: " . $mediaServer->server[0]->sshPort . "\n");
    print("Organization ID: " . $mediaServer->organizationId->id . "\n");
  }
}
?>
