<?php
/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2015 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */


require_once "SampleHelper.php";
require_once "./generated/MailingService.php";

class TagSample
{
  private $service;
  private $helper;

  public function __construct($service)
  {
    $this->service = $service;
    $this->helper = new SampleHelper($service);
  }

  public function createTag($tagName)
  {
    $tag = new Tag();
    $tag->name = $tagName;
    $tag->description = "Created using .net samples";
    $tag->createdTimeSpecified = false;
    $tag->modifiedTimeSpecified = false;

    $tagValue1 = new TagValue();
    $tagValue1->value = "demovalue-1";

    $tagValue2 = new TagValue();
    $tagValue2->value = "demovalue2";

    $tagValue3 = new TagValue();
    $tagValue3->value = "demovalue-3";

    // Add tag values to tag
    $tag->tagValue = array();
    $tag->tagValue[] = $tagValue1;
    $tag->tagValue[] = $tagValue2;
    $tag->tagValue[] = $tagValue3;

    $response = $this->helper->create($tag);

    return $response->objectId;
  }

  /**
   * Get and print tag object to standard out.
   *
   * @param targetId the tag ID that will be retrieved and printed.
   * @throws Exception any exception
   */
  public function getAndPrint($tagId)
  {
    $tags = $this->helper->get(array($tagId));
    $tag = $tags[0];

    // Print target to standard out
    print("\nTag:" . "\n");
    print("TagId: " . $tag->objectId->id . "\n");
    print("Name: " . $tag->name . "\n");
  }
}
?>
