# Copyright 2014, StrongMail Systems, Inc.  All rights reserved.

require 'SampleHelper'

class SystemAddressSample
  def initialize(svc)
    @svc = svc
  end


  # List SystemAddress by type (bounce/from/reply) and email address.
  #  There is no filter by email address, so we need to get all address for one type and filter them again.
  #  type is the SystemAddressType with value BOUNCE, FROM and REPLY.
  #  emailAddress is the email address to match
  #  return the system address of type matching given email address.
  def listByEmailAddress(type, emailAddress)
    # Create and set attribute for filter
    filter = SystemAddressFilter.new
    SampleHelper::setFilter(filter)

    # Create type condition
    typeCondition = ScalarStringFilterCondition.new
    typeCondition.operator = "EQUAL"
    typeCondition.value = type
    filter.typeCondition = typeCondition

    # Create request and make call
    addressIds = SampleHelper::list(@svc, filter)

    # Go through all addresses to get the one that matches email address
    for addressId in addressIds
      address = SampleHelper::get(@svc, addressId)
      if (address.emailAddress == emailAddress)
        return address
      end
    end
  end

end
