#!/bin/bash

# ---------------------------------------------------------------------- #
#  STRONGMAIL SYSTEMS                                                    #
#                                                                        #
#  (c) Copyright StrongMail Systems, Inc. - All rights reserved. #
#                                                                        #
#  Visit http://www.strongmail.com for more information                  #
#                                                                        #
#  You may incorporate this source code in your application only if      #
#  you own a valid license to do so from StrongMail Systems, Inc.        #
#  and the copyright notices are not removed from the source code.       #
#                                                                        #
#  Distributing our source code outside your organization                #
#  requires a distribution license.                                      #
#                                                                        #
# ---------------------------------------------------------------------- #


MS_RUBY_INSTALL_DIR=`pwd`/ruby
echo "Script will insall ruby in $MS_RUBY_INSTALL_DIR dir. Continue? "
while true
do
   echo -n "Please confirm (y or n) :"
   read CONFIRM
   case $CONFIRM in
      y|Y|YES|yes|Yes) break ;;
      n|N|no|NO|No)
         echo Aborting Installtion
         exit
      ;;
   esac
done

echo "Downloading ruby..."

if wget "http://cache.ruby-lang.org/pub/ruby/2.1/ruby-2.1.0.tar.gz"; then
   echo "Download Completed"
   echo "Installing ruby..."
else 
   echo "Unable to download. Aborting...";
   exit
fi

tar -xzf ruby-2.1.0.tar.gz 
if cd ruby-2.1.0; then
   echo "STEP - 1/4 Configuring"
else   
   echo "Error in extracing the tar. Existing..."
   exit 1;
fi
./configure --prefix $MS_RUBY_INSTALL_DIR > `pwd`/../rubyconfig.log

echo "STEP - 2/4 Installing Ruby..."
make install > `pwd`/../rubyinstall.log

echo "Downloading SOAP4r "
if wget "https://rubygems.org/downloads/mumboe-soap4r-1.5.8.7.gem" --no-check-certificate; then
   echo "Download Completed"
   echo "STEP 3/4 Installing soap4r"
   $MS_RUBY_INSTALL_DIR/bin/gem install mumboe-soap4r-1.5.8.7.gem 
else 
 echo "Unable to download soap4r...";
fi

if wget "https://rubygems.org/downloads/httpclient-2.3.4.1.gem"; --no-check-certificate; then
   echo "Download Completed"
   echo "STEP 4/4 Installing httpclient-2.3.4.1"
   $MS_RUBY_INSTALL_DIR/bin/gem install httpclient-2.3.4.1.gem
else 
   echo "Unable to download httpclient";
fi


echo "Creating the symbolic link"
ln -s $MS_RUBY_INSTALL_DIR/bin/ruby /usr/bin/ruby210
ruby2.1.0 --version

echo "Installation Completed. Please check rubyconfig.log" 
