/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2014 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */

package com.strongmail.webserviceclient.samples.cxf;


import com.strongmail.webserviceclient.samples.cxf.generated.AuthorizationFault;
import com.strongmail.webserviceclient.samples.cxf.generated.BadHandleFault;
import com.strongmail.webserviceclient.samples.cxf.generated.InvalidObjectFault;
import com.strongmail.webserviceclient.samples.cxf.generated.MailingService;
import com.strongmail.webserviceclient.samples.cxf.generated.ObjectNotFoundFault;
import com.strongmail.webserviceclient.samples.cxf.generated.UnexpectedFault;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ArrayStringFilterCondition;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.AttachmentId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.BaseStandardMailingId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.BaseTransactionalMailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.CancelRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelHeader;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelMailingFilter;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelStandardMailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelStandardMailingId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelTemplateId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelTransactionalMailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ChannelTransactionalMailingId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.CloseRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ContentBlockId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.DataSourceId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.FilterArrayOperator;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.FilterIdScalarOperator;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.FilterStringScalarOperator;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.GetRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.GetTxnEasInfoRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.GetTxnEasInfoResponse;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.GetTxnMailingHandleRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.IncludedTargetField;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.InternalDataSourceId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.LaunchRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.LaunchResponse;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ListRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ListResponse;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.LoadRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.Mailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.MailingFilter;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.MailingId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.MailingOrderBy;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.NameValuePair;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ObjectId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.PauseRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.PersonalizeMailingRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.PersonalizeResponse;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ResumeRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ScalarIdFilterCondition;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ScalarStringFilterCondition;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.SchedulableMailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.SeedListId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.ScheduleRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.SendRecord;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.StandardMailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.StandardMailingId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.StandardMailingNotification;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.SuppressionListId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.SystemAddressId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.Tag;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TagFilter;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TagId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TagValue;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TagValueId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TargetId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TemplateId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TransactionalMailing;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TransactionalMailingId;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.TxnSendRequest;

import java.math.BigInteger;
import java.util.Date;
import java.util.List;


public class MailingSample
{
  private MailingService service;
  private SampleHelper helper;

  //
  private TemplateSample templateSample;
  private ContentBlockSample contentBlockSample;
  private SystemAddressSample addressSample;
  private DataSourceSample dataSourceSample;
  private AttachmentSample attachmentSample;
  private TargetSample targetSample;


  public MailingSample(MailingService service)
  {
    this.service = service;
    helper = new SampleHelper();
    templateSample = new TemplateSample(service);
    contentBlockSample = new ContentBlockSample(service);
    addressSample = new SystemAddressSample(service);
    dataSourceSample = new DataSourceSample(service);
    attachmentSample = new AttachmentSample(service);
    targetSample = new TargetSample(service);

  }


  /**
   * Create a recurring mailing with no excluded target.
   *
   * @param mailingName    the name of the mailing to be created
   * @return MailingId
   * @throws Exception any exception
   */
  public StandardMailingId createStandardMailing(String mailingName) throws Exception
  {
    StandardMailing mailing = new StandardMailing();
    TemplateId templateId = templateSample.createTemplate("Template_"+mailingName);
    setMailingCommonFields(mailing, mailingName, templateId);
    mailing.getHeader().add("mailing header");

    SystemAddressId bounceId = (SystemAddressId)addressSample.listByEmailAddress("bounce","bounce@sample.com").getObjectId();
    SystemAddressId fromId = (SystemAddressId)addressSample.listByEmailAddress("from","from@sample.com").getObjectId();
    SystemAddressId replyId = (SystemAddressId)addressSample.listByEmailAddress("reply","reply@sample.com").getObjectId();

    mailing.setBounceAddressId(bounceId);
    mailing.setFromAddressId(fromId);
    mailing.setFromName("From Name");
    mailing.setReplyAddressId(replyId);
    mailing.setSubject("mailing subject");

    mailing.setDescription("StandardMailing from CXF");
    mailing.setEliminateDuplicates(true);
    SchedulableMailing.Schedule schedule = new SchedulableMailing.Schedule();

    mailing.setType("RECURRING");
    // Set schedule: daily recurrence with every two days
    SchedulableMailing.Schedule.Recurrence.DailyRecurrence daily =
      new SchedulableMailing.Schedule.Recurrence.DailyRecurrence();
    daily.setInterval(2);
    SchedulableMailing.Schedule.Recurrence recurrence = new SchedulableMailing.Schedule.Recurrence();
    recurrence.setEndAfterXMailings(100); // launch 100 mailing;
    recurrence.setDailyRecurrence(daily);
    schedule.setRecurrence(recurrence);

    schedule.setStartDateTime(new Date(System.currentTimeMillis() + 3600000)); // one hour later
    mailing.setSchedule(schedule);

    // Set dependencies
    // Set dependencies
    AttachmentId attachmentId = attachmentSample.createAttachment("Attachement_"+mailingName);
    mailing.getAttachmentId().add(attachmentId);

    ContentBlockId contentBlockId = contentBlockSample.createContentBlock("ContentBlock_"+mailingName);
    mailing.getContentBlockId().add(contentBlockId);

    DataSourceId dataSourceId = dataSourceSample.createIDS("IDS_"+mailingName);
    TargetId targetId = targetSample.createTarget("Target_"+mailingName,dataSourceId);
    mailing.getIncludedTargetId().add(targetId);

    SeedListId seedId = new SeedListSample(service).createSeedList("Seed_"+mailingName);
    mailing.getSeedListId().add(seedId);

    SuppressionListId suppressId = new SuppressionListSample(service).createSuppressionList("Suppress"+mailingName);
    mailing.getSuppressionListId().add(suppressId);
    mailing.setUseHeaderFromTemplate(false);
    mailing.setCcAddress("test_cc@strongmail.com");
    mailing.setBccAddress("test_bcc@strongmail.com");

    // Add Notification options
    StandardMailingNotification mailingNotification = new StandardMailingNotification();
    mailingNotification.setNotifyTargetingCompletion(true);
    mailingNotification.setNotifyStateChange(true);
    mailingNotification.getRecipientAddresses().add("test1_test@strongmail.com");
    mailingNotification.getRecipientAddresses().add("test2_test@strongmail.com");
    mailingNotification.getRecipientAddresses().add("test3_test@strongmail.com");

    mailing.setNotificationOption(mailingNotification);

    mailing.setMaxRecipientLimit(new BigInteger("123"));

    mailing.setMinRecipientLimit(new BigInteger("2"));

    StandardMailingId mId = (StandardMailingId)helper.create(mailing);

    // Make call
    StandardMailing m = (StandardMailing) helper.get(mId);

    m.setCreatedTime(null);
    m.setModifiedTime(null);

    // Schedule
    mailing.setSchedule(createDailySchedule());
    mailing.setType("RECURRING");

    helper.update(m);

    return mId;

  }

   /**
   * Create oneTimeMailing
   *
   * @param mailingName    the name of the mailing to be created
   * @return MailingId
   * @throws Exception any exception
   */
  public StandardMailingId createOneTimeStandardMailing(String mailingName) throws Exception
  {
    StandardMailing mailing = new StandardMailing();
    TemplateId templateId = templateSample.createTemplate("Template "+mailingName);
    setMailingCommonFields(mailing, mailingName, templateId);
    mailing.getHeader().add("mailing header");

    // Fetch/Create sample addresses
    SystemAddressId bounceId = (SystemAddressId)addressSample.listByEmailAddress("bounce","bounce@sample.com").getObjectId();
    SystemAddressId fromId = (SystemAddressId)addressSample.listByEmailAddress("from","from@sample.com").getObjectId();
    SystemAddressId replyId = (SystemAddressId)addressSample.listByEmailAddress("reply","reply@sample.com").getObjectId();
    mailing.setBounceAddressId(bounceId);
    mailing.setFromAddressId(fromId);
    mailing.setFromName("From Name");
    mailing.setReplyAddressId(replyId);
    mailing.setSubject("mailing subject");

    mailing.setDescription("StandardMailing from CXF");
    mailing.setEliminateDuplicates(true);
    SchedulableMailing.Schedule schedule = new SchedulableMailing.Schedule();

    mailing.setType("ONE_TIME");
    schedule.setStartDateTime(new Date(System.currentTimeMillis() + 3600000)); // one hour later
    mailing.setSchedule(schedule);

    // Set dependencies
    AttachmentId attachmentId = attachmentSample.createAttachment("Attachement_"+mailingName);
    mailing.getAttachmentId().add(attachmentId);

    ContentBlockId contentBlockId = contentBlockSample.createContentBlock("ContentBlock_"+mailingName);
    mailing.getContentBlockId().add(contentBlockId);

    DataSourceId dataSourceId = dataSourceSample.createIDS("IDS_"+mailingName);
    TargetId targetId = targetSample.createTarget("Target_"+mailingName,dataSourceId);
    mailing.getIncludedTargetId().add(targetId);

    SeedListId seedId = new SeedListSample(service).createSeedList("Seed_"+mailingName);
    mailing.getSeedListId().add(seedId);

    SuppressionListId suppressId = new SuppressionListSample(service).createSuppressionList("Suppress"+mailingName);
    mailing.getSuppressionListId().add(suppressId);
    mailing.setUseHeaderFromTemplate(false);
    mailing.setCcAddress("test_cc@strongmail.com");
    mailing.setBccAddress("test_bcc@strongmail.com");

    // Add Notification options
    StandardMailingNotification mailingNotification = new StandardMailingNotification();
    mailingNotification.setNotifyTargetingCompletion(true);
    mailingNotification.setNotifyStateChange(true);
    mailingNotification.getRecipientAddresses().add("test1_test@strongmail.com");
    mailingNotification.getRecipientAddresses().add("test2_test@strongmail.com");
    mailingNotification.getRecipientAddresses().add("test3_test@strongmail.com");

    mailing.setNotificationOption(mailingNotification);

    mailing.setMaxRecipientLimit(new BigInteger("123"));

    mailing.setMinRecipientLimit(new BigInteger("2"));

    StandardMailingId mId = (StandardMailingId)helper.create(mailing);

    // Make call
    return mId;
  }

  private SchedulableMailing.Schedule createDailySchedule()
  {
    SchedulableMailing.Schedule schedule = new SchedulableMailing.Schedule();

    schedule.setStartDateTime(new Date(System.currentTimeMillis() + Integer.MAX_VALUE / 2));

    SchedulableMailing.Schedule.Recurrence.DailyRecurrence daily =
      new SchedulableMailing.Schedule.Recurrence.DailyRecurrence();
    daily.setInterval(2);

    SchedulableMailing.Schedule.Recurrence recurrence =
      new SchedulableMailing.Schedule.Recurrence();
    recurrence.setDailyRecurrence(daily);
    recurrence.setEndDate(new Date(System.currentTimeMillis() + Integer.MAX_VALUE));

    schedule.setRecurrence(recurrence);
    return schedule;
  }

  /**
   * Create a recurring mailing with no excluded target.
   *
   * @param mailingName    the name of the mailing to be created
   * @return MailingId
   * @throws Exception any exception
   */
  public ChannelStandardMailingId createChannelStdMailing(String mailingName) throws Exception
  {
    ChannelStandardMailing mailing = new ChannelStandardMailing();
    mailing.setBodyEncoding("BASE_64");
    mailing.setFieldDelimiter("::");
    mailing.setHeaderEncoding("EIGHT_BIT");
    mailing.setIsApproved(true);
    mailing.setIsCompliant(true);
    mailing.setName(mailingName);
    // One of the two
    mailing.setOutputBodyCharSet(null);
    mailing.setOutputBodyCharSetToken("##body token##");

    // One of the two
    mailing.setOutputHeaderCharSet(null);
    mailing.setOutputHeaderCharSetToken("##header token##");
    mailing.setPriority("NORMAL");
    // Below property also ignored
    mailing.getFormat().add("HTML");
    ChannelId channelId = new ChannelId();
    channelId.setId("2");
    mailing.setChannelId(channelId);

    ChannelTemplateId channelTemplateId = new TemplateSample(service).createChannelTemplate("ChannelTemplate_" + mailingName);
    mailing.setTemplateId(channelTemplateId);

    mailing.setDescription("StandardMailing from CXF");
    mailing.setEliminateDuplicates(true);
    SchedulableMailing.Schedule schedule = new SchedulableMailing.Schedule();

    mailing.setType("ONE_TIME");

    // Set dependencies
    ContentBlockId contentBlockId = new ContentBlockSample(service).createContentBlock("content_block_" + mailingName);
    mailing.getContentBlockId().add(contentBlockId);

    InternalDataSourceId dataSourceId  = new DataSourceSample(service).createIDS("IDS_" + mailingName);
    SeedListId seedListId = new SeedListSample(service).createChannelSeedList("Seed_"+ mailingName);
    TargetId targetId = new TargetSample(service).createChannelTarget("Target_"+ mailingName,dataSourceId);
    SuppressionListId suppressionListId = new SuppressionListSample(service).createChannelSuppressionList("Suppression_"+mailingName);

    IncludedTargetField includedTargetField = new IncludedTargetField();
    includedTargetField.setTargetId(targetId);
    includedTargetField.setSuppressionColumnName("id");
    includedTargetField.setSeedColumnName("id");

    // Add targetfield to mailing
    mailing.getIncludedTarget().add(includedTargetField);

    // Add Notification options
    StandardMailingNotification mailingNotification = new StandardMailingNotification();
    mailingNotification.setNotifyTargetingCompletion(true);
    mailingNotification.setNotifyStateChange(true);
    mailingNotification.getRecipientAddresses().add("test1_test@strongmail.com");
    mailingNotification.getRecipientAddresses().add("test2_test@strongmail.com");
    mailingNotification.getRecipientAddresses().add("test3_test@strongmail.com");

    mailing.setNotificationOption(mailingNotification);
    mailing.setMaxRecipientLimit(new BigInteger("123"));
    mailing.setMinRecipientLimit(new BigInteger("2"));

    // Add headers
    ChannelHeader header1 = new ChannelHeader();
    header1.setHeaderName("CustomUserHeader1");
    header1.setHeaderValue("CustomUserHeaderValue1");
    // Channel Header will be set irrespective of the specified value

    ChannelHeader header2 = new ChannelHeader();
    header2.setHeaderName("CustomUserHeader2");
    header2.setHeaderValue("CustomUserHeaderValue2");

    ChannelHeader header3 = new ChannelHeader();
    header3.setHeaderName("CustomUserHeader3");
    header3.setHeaderValue("CustomUserHeaderValue3");

    mailing.getChannelHeader().add(header1);
    mailing.getChannelHeader().add(header2);
    mailing.getChannelHeader().add(header3);

    mailing.getSeedListId().add(seedListId);
    mailing.getSuppressionListId().add(suppressionListId);
    mailing.setUseHeaderFromTemplate(false);

    // Add profileAttributes - They must be a part of target.
    mailing.getChannelProfileAttribute().add("name");
    mailing.getChannelProfileAttribute().add("id");


    ChannelStandardMailingId mId = (ChannelStandardMailingId)helper.create(mailing);

    ChannelStandardMailing m = (ChannelStandardMailing) helper.get(mId);

    System.out.println("Channel Standard Mailing Created Successfully");

    m.setCreatedTime(null);
    m.setModifiedTime(null);
    m.setName("Updated_"+mailingName);

    helper.update(m);

    System.out.println("Channel Standard Mailing Updated Successfully");

    LaunchRequest launchRequest = new LaunchRequest();
    launchRequest.setMailingId((BaseStandardMailingId)m.getObjectId());

    LaunchResponse launchResponse = service.launch(launchRequest);

    System.out.println("Launch Operation was "+ (launchResponse.isSuccess()? "successful.":"un-successful." ));

    // Make call
    return mId;
  }


  /**
   * Create a Transactional Mailing.
   *
   * @param mailingName the name of the mailing
   * @return TransactionalMailingId
   * @throws Exception any exception
   */
  public TransactionalMailingId createTransactionalMailing(String mailingName)
    throws Exception
  {

    TransactionalMailing mailing = new TransactionalMailing();
    TemplateId templateId = templateSample.createTemplate("Template_"+mailingName);
    setMailingCommonFields(mailing, mailingName, templateId);
    mailing.getHeader().add("mailing header");
    SystemAddressId bounceId = (SystemAddressId)addressSample.listByEmailAddress("bounce","bounce@sample.com").getObjectId();
    SystemAddressId fromId = (SystemAddressId)addressSample.listByEmailAddress("from","from@sample.com").getObjectId();
    SystemAddressId replyId = (SystemAddressId)addressSample.listByEmailAddress("reply","reply@sample.com").getObjectId();

    mailing.setBounceAddressId(bounceId);
    mailing.setFromAddressId(fromId);
    mailing.setFromName("From Name");
    mailing.setReplyAddressId(replyId);
    mailing.setSubject("mailing subject");

    mailing.setDescription("TransactionalMailing from CXF");
    mailing.setType("TRANSACTIONAL");

    DataSourceId dataSourceId = dataSourceSample.createIDS("IDS_"+mailingName);
    TargetId targetId = targetSample.createTarget("Target_"+mailingName,dataSourceId);
    mailing.setTargetId(targetId);

    return (TransactionalMailingId)helper.create(mailing);
  }


  /**
   * Create a Transactional Mailing.
   *
   * @param mailingName the name of the mailing
   * @return TransactionalMailingId
   * @throws Exception any exception
   */
  public ChannelTransactionalMailingId createChannelTxMailing(String mailingName)
    throws Exception
  {

    ChannelTransactionalMailing mailing = new ChannelTransactionalMailing();

    mailing.setDescription("TransactionalMailing from CXF");
    mailing.setType("TRANSACTIONAL");
    mailing.setBodyEncoding("BASE_64");
    mailing.setFieldDelimiter("::");
    mailing.setHeaderEncoding("EIGHT_BIT");
    mailing.setIsApproved(true);
    mailing.setIsCompliant(true);
    mailing.setName(mailingName);
    // One of the two
    mailing.setOutputBodyCharSet(null);
    mailing.setOutputBodyCharSetToken("##body token##");

    // One of the two
    mailing.setOutputHeaderCharSet(null);
    mailing.setOutputHeaderCharSetToken("##header token##");
    mailing.setPriority("NORMAL");
    // The getFormat will be ingnored.
    mailing.getFormat().add("HTML");


    ChannelTemplateId templateId = new TemplateSample(service).createChannelTemplate("Template_"+mailingName);
    InternalDataSourceId dataSourceId  = new DataSourceSample(service).createIDS("IDS_" + mailingName);
    TargetId targetId = new TargetSample(service).createChannelTarget("Target_" + mailingName, dataSourceId);

    mailing.setTemplateId(templateId);
    mailing.setTargetId(targetId);

    ChannelId channelId = new ChannelId();
    channelId.setId("2");
    mailing.setChannelId(channelId);

    ChannelTransactionalMailingId channelTransactionalMailingId = (ChannelTransactionalMailingId)helper.create(mailing);

    ChannelTransactionalMailing createdMailing = (ChannelTransactionalMailing)helper.get(channelTransactionalMailingId);

    System.out.println("Channel Transactional Mailing created Successful");

    createdMailing.setModifiedTime(null);
    createdMailing.setCreatedTime(null);
    createdMailing.setName("Update_"+mailingName);

    helper.update(createdMailing);

    System.out.println("Channel Transactional Mailing updated Successful");

    LoadRequest loadRequest = new LoadRequest();
    loadRequest.setMailingId(channelTransactionalMailingId);

    System.out.println(
      "Load operation on " + channelTransactionalMailingId.getId() + " was " + (service.load(loadRequest).isSuccess() ? "successful" : "unsuccessful")
    );

    return channelTransactionalMailingId;
  }


  private void setMailingCommonFields(Mailing mailing,
                                      String mailingName,
                                      TemplateId templateId)
  {
    mailing.setBodyEncoding("BASE_64");
    mailing.setFieldDelimiter("::");
    mailing.setHeaderEncoding("EIGHT_BIT");
    mailing.setIsApproved(true);
    mailing.setIsCompliant(true);
    mailing.setName(mailingName);
    // One of the two
    mailing.setOutputBodyCharSet(null);
    mailing.setOutputBodyCharSetToken("##body token##");

    // One of the two
    mailing.setOutputHeaderCharSet(null);
    mailing.setOutputHeaderCharSetToken("##header token##");
    mailing.setPriority("NORMAL");
    mailing.setRowDelimiter("\n");
    mailing.setTemplateId(templateId);
    mailing.getFormat().add("HTML");

    // Add tags to mailing
    addTagsToMailing(mailing);

    // Set LETI property
    mailing.setLinkExpiryInterval("fortyeight_hours");
  }

  public void getAndPrint(MailingId mailingId) throws Exception
  {
    Mailing mailing = (Mailing)helper.get(mailingId);

    // Print Mailing to standard out
    if (mailingId instanceof BaseStandardMailingId)
    {
      if(mailing instanceof  StandardMailing)
      {
        printStandardMailing((StandardMailing)mailing);
      }
      else
      {
        printStandardMailing((ChannelStandardMailing)mailing);
      }
    }
    else if (mailing instanceof BaseTransactionalMailing)
    {
      if(mailing instanceof TransactionalMailing)
      {
        printTransactionalMailing((TransactionalMailing)mailing);
      }
      else
      {
        printTransactionalMailing((ChannelTransactionalMailing)mailing);
      }
    }
  }

  private void printMailing(Mailing mailing)
  {
    System.out.println("MailingId: " + mailing.getObjectId().getId());
    System.out.println("Name: " + mailing.getName());
    System.out.println("CampaignId: " + mailing.getCampaignId());
    System.out.println("CreatedTime: " + mailing.getCreatedTime());
    System.out.println("Description: " + mailing.getDescription());
    System.out.println("ModifiedTime: " + mailing.getModifiedTime());
    System.out.println("OrganizationId: " + mailing.getOrganizationId().getId());
    System.out.println("OwnerId: " + mailing.getOwnerId().getId());
    System.out.println("FieldDelimiter: " + mailing.getFieldDelimiter());
    System.out.println("RowDelimiter: " + mailing.getRowDelimiter());
    System.out.println("MessageFormats: " + mailing.getFormat());
    System.out.println("Template: " + mailing.getTemplateId().getId());
    System.out.println("BodyEncoding: " + mailing.getBodyEncoding());
    System.out.println("HeaderEncoding: " + mailing.getHeaderEncoding());
    System.out.println("LastGoodStatus: " + mailing.getLastGoodStatus());
    //System.out.println("MailingClass: " + mailing.getMailingClassId().getId());
    if(mailing.getOutputBodyCharSet() != null)
    {
      System.out.println("BodyCharset: " + mailing.getOutputBodyCharSet().value());
    }
    System.out.println("BodyOutputToken: " + mailing.getOutputBodyCharSetToken());
    if(mailing.getOutputHeaderCharSet() != null)
    {
      System.out.println("HeaderCharset: " + mailing.getOutputHeaderCharSet().value());
    }
    System.out.println("HeaderOutputToken: " + mailing.getOutputHeaderCharSetToken());
    System.out.println("Parent: " + mailing.getParentId());
    System.out.println("PlannedLaunchDate: " + mailing.getPlannedLaunchDate());
    System.out.println("Priority: " + mailing.getPriority());
    System.out.println("ServerErrorCode: " + mailing.getServerErrorCode());
    System.out.println("ServerErrorMessage: " + mailing.getServerErrorMessage());
    System.out.println("Status: " + mailing.getStatus());
    System.out.println("Type: " + mailing.getType());
    System.out.println("Link Expiry Time Interval: "+mailing.getLinkExpiryInterval());
  }

  private void printStandardMailing(StandardMailing m)
  {
    System.out.println("\n Standard Mailing \n");
    printMailing(m);
    System.out.println("Headers: " + m.getHeader());
    System.out.println("FromName: " + m.getFromName());
    System.out.println("Bounce: " + m.getBounceAddressId().getId());
    System.out.println("From: " + m.getFromAddressId().getId());
    System.out.println("Reply: " + m.getReplyAddressId().getId());
    System.out.println("Subject: " + m.getSubject());
    System.out.println("IncludedTarget: " + SampleHelper.formatIdList(m.getIncludedTargetId()));
    System.out.println("SeedList: " + SampleHelper.formatIdList(m.getSeedListId()));
    System.out.println("SuppressionList: " + SampleHelper.formatIdList(m.getSuppressionListId()));
    System.out.println("AttachmentId: " + SampleHelper.formatIdList(m.getAttachmentId()));
    System.out.println("ContentBlockId: " + SampleHelper.formatIdList(m.getContentBlockId()));
  }

  private void printStandardMailing(ChannelStandardMailing m)
  {
    System.out.println("\n ChannelStandard Mailing \n");
    printMailing(m);

    System.out.println("SeedList: " + SampleHelper.formatIdList(m.getSeedListId()));
    System.out.println("SuppressionList: " + SampleHelper.formatIdList(m.getSuppressionListId()));
    System.out.println("AttachmentId: " + SampleHelper.formatIdList(m.getAttachmentId()));
    System.out.println("ContentBlockId: " + SampleHelper.formatIdList(m.getContentBlockId()));
    printMqHeaders(m.getChannelHeader());

    if(m.getChannelProfileAttribute().size() >0)
    {
      System.out.println("Profile Attributes - ");
      for(String field:m.getChannelProfileAttribute())
      {
        System.out.println(" - "+field);
      }
    }
  }

  private void printTransactionalMailing(TransactionalMailing m)
  {
    System.out.println("\n Transactional Mailing \n");
    System.out.println("Headers: " + m.getHeader());
    System.out.println("FromName: " + m.getFromName());
    System.out.println("Bounce: " + m.getBounceAddressId().getId());
    System.out.println("From: " + m.getFromAddressId().getId());
    System.out.println("Reply: " + m.getReplyAddressId().getId());
    System.out.println("Subject: " + m.getSubject());
    System.out.println("FormatField: " + m.getFormatFieldName());
    System.out.println("MailingConfig: " + m.getMailingConfig());
    System.out.println("RecordStructure: " + m.getRecordStructure());
    System.out.println("SenderNumber: " + m.getSenderNumber());
    System.out.println("Target: " + m.getTargetId().getId());
  }

  private void printTransactionalMailing(ChannelTransactionalMailing m)
  {
    System.out.println("\n Channel Transactional Mailing \n");
    System.out.println("MailingConfig: " + m.getMailingConfig());
    System.out.println("RecordStructure: " + m.getRecordStructure());
    System.out.println("Target: " + m.getTargetId().getId());
    printMqHeaders(m.getChannelHeader());
  }

  private void printMqHeaders(List<ChannelHeader> channelHeaders)
  {
    if(channelHeaders != null && channelHeaders.size() > 0 )
    {
      System.out.println("ChannelHeaders :");
      for(ChannelHeader header:channelHeaders)
      {
        System.out.println("Name:"+header.getHeaderName() +" ,  Value:"+header.getHeaderValue());
      }
    }
  }

  /**
   * Launch a Standard Mailing.
   *
   * @param mailingId the ID of Standard Mailing that will be launched
   * @return if launch operation is successful
   * @throws Exception any exception
   */
  public boolean launchMailing(StandardMailingId mailingId) throws Exception
  {
    LaunchRequest request = new LaunchRequest();
    request.setMailingId(mailingId);

    return service.launch(request).isSuccess();
  }

  /**
   * Launch a Standard Mailing.
   *
   * @param mailingId the ID of Standard Mailing that will be launched
   * @return if launch operation is successful
   * @throws Exception any exception
   */
  public boolean scheduleMailing(StandardMailingId mailingId) throws Exception
  {
    ScheduleRequest request = new ScheduleRequest();
    request.setMailingId(mailingId);

    return service.schedule(request).isSuccess();
  }

  /**
   * Load a Transactional Mailing.
   *
   * @param mailingId the ID of Transactional Mailing that will be loaded
   * @return if load operation is successful
   * @throws Exception any exception
   */
  public boolean loadMailing(TransactionalMailingId mailingId) throws Exception
  {
    LoadRequest request = new LoadRequest();
    request.setMailingId(mailingId);

    return service.load(request).isSuccess();
  }


  /**
   * Fetch the handle for a tx mailing, that is to be used in the txnSend API.   
   *
   * @param mailingId
   * @return mailing handle
   * @throws Exception
   */
  public String getTxnMailingHandle(TransactionalMailingId mailingId) throws Exception
  {
    // Create request and set mailingId
    GetTxnMailingHandleRequest request = new GetTxnMailingHandleRequest();
    request.setMailingId(mailingId);
    return service.getTxnMailingHandle(request).getHandle();
  }

  public boolean txnSend(String mailingHandle) throws Exception
  {
    // Create request and set mailingId
    TxnSendRequest request = new TxnSendRequest();
    request.setHandle(mailingHandle);

    // Create record based on the target created in TargetSample
    SendRecord record = new SendRecord();

    NameValuePair pair1 = new NameValuePair();
    pair1.setName("ID");
    pair1.setValue("10");
    record.getField().add(pair1);

    NameValuePair pair2 = new NameValuePair();
    pair2.setName("EMAIL_ADDRESS");
    pair2.setValue("sample1@cxf.sample.com");
    record.getField().add(pair2);

    NameValuePair pair3 = new NameValuePair();
    pair3.setName("NAME");
    pair3.setValue("First Last");
    record.getField().add(pair3);

    // Add record and make call
    request.getSendRecord().add(record);
    boolean success = false;
    try
    {
      success = service.txnSend(request).isSuccess();
    }
    catch (BadHandleFault e)
    {
      System.out.println("Encountered a BadHandleFault. " + e.getFaultInfo().getFaultMessage());
      System.out.println("This indicates that the handle being used to attempt the txnSend call is incorrect.");
      System.out.println("Please ensure that you send the correct handle using the getTxnMailingHandle() API.");
    }
    return success;
  }

  public void printTxnEASInfo(TransactionalMailingId mailingId) throws Exception
  {
    // Create request and set mailingId
    GetTxnEasInfoRequest request = new GetTxnEasInfoRequest();
    request.setMailingId(mailingId);
    GetTxnEasInfoResponse response = service.getTxnEasInfo(request);

    System.out.println("EAS Info for Tx mailing ID: " + mailingId.getId());
    System.out.println("EAS on which the txn mailing has been loaded: " + response.getHostname());
    System.out.println("Txn mailing handle: " + response.getMailingHandle());
    System.out.println("Txn mailing name: " + response.getMailingName());
  }

  /**
   * Close a Transactional Mailing.
   *
   * @param mailingId the ID of Transactional Mailing that will be closed
   * @return if close operation is successful
   * @throws Exception any exception
   */
  public boolean close(TransactionalMailingId mailingId) throws Exception
  {
    CloseRequest request = new CloseRequest();
    request.setMailingId(mailingId);

    return service.close(request).isSuccess();
  }

  public boolean cancel(MailingId mailingId) throws Exception
  {
    CancelRequest request = new CancelRequest();
    request.setMailingId(mailingId);

    return service.cancel(request).isSuccess();
  }


  public boolean pause(MailingId mailingId) throws Exception
  {
    PauseRequest request = new PauseRequest();
    request.setMailingId(mailingId);

    return service.pause(request).isSuccess();
  }


  public boolean resume(MailingId mailingId) throws Exception
  {
    ResumeRequest request = new ResumeRequest();
    request.setMailingId(mailingId);

    return service.resume(request).isSuccess();
  }

  /**
   * List mailings by name: this should return one mailing if name is matched.
   *
   * @param name the mailing name to be listed
   * @throws Exception any exception
   */
  public void listByName(String name, boolean isEmailChannel) throws Exception
  {
    MailingFilter filter = isEmailChannel ? new MailingFilter() : new ChannelMailingFilter() ;
    helper.setFilter(filter);
    filter.getOrderBy().add(MailingOrderBy.MODIFIED_TIME);

    // Create name condition
    ScalarStringFilterCondition nameCondition = new ScalarStringFilterCondition();
    nameCondition.setOperator(FilterStringScalarOperator.EQUAL);
    nameCondition.setValue(name);
    filter.setNameCondition(nameCondition);

    if(!isEmailChannel)
    {
      // Set the channel id
      ChannelId channelId = new ChannelId();
      channelId.setId("2");
      ScalarIdFilterCondition idFilterCondition = new ScalarIdFilterCondition();
      idFilterCondition.setOperator(FilterIdScalarOperator.EQUAL);
      idFilterCondition.setValue(channelId);
      ((ChannelMailingFilter)filter).setChannelIdCondition(idFilterCondition);
    }

    // Set the filter to request
    ListRequest request = new ListRequest();
    request.setFilter(filter);

    // Make call and print results
    printListResponse(service.list(request));
  }

  /**
   * List mailing in an organization: this can be done using an empty filter. The organization is
   * the one from header.
   *
   * @throws Exception any exception
   */
  public void listByOrganization(boolean isEmailChannel) throws Exception
  {
    // Create empty filter: no conditions
    MailingFilter filter = isEmailChannel ? new MailingFilter() : new ChannelMailingFilter();
    helper.setFilter(filter);
    filter.getOrderBy().add(MailingOrderBy.MODIFIED_TIME);

    // Set the filter to request
    ListRequest request = new ListRequest();
    request.setFilter(filter);

    // Make call and print results
    printListResponse(service.list(request));
  }

  /**
   * List mailings by mailing type and status.
   *
   * @throws Exception any exception
   */
  public void listByTypeAndStatus(boolean isEmailChannel) throws Exception
  {
    // Create a mailing filter and set attribute and order by list
    MailingFilter filter = isEmailChannel ? new MailingFilter() : new ChannelMailingFilter();
    helper.setFilter(filter);
    filter.getOrderBy().add(MailingOrderBy.NAME);
    filter.getOrderBy().add(MailingOrderBy.MODIFIED_TIME);

    // Create status condition: status in (ACTIVE, EDITING, COMPLETED)
    ArrayStringFilterCondition statusCondition = new ArrayStringFilterCondition();
    statusCondition.setOperator(FilterArrayOperator.IN);
    statusCondition.getValue().add("ACTIVE");
    statusCondition.getValue().add("EDITING");
    statusCondition.getValue().add("COMPLETED");
    filter.setStatusCondition(statusCondition);

    // Create Type Condition: type in (RECURRING, TRANSACTIONAL)
    ArrayStringFilterCondition typeCondition = new ArrayStringFilterCondition();
    typeCondition.setOperator(FilterArrayOperator.IN);
    typeCondition.getValue().add("RECURRING");
    typeCondition.getValue().add("TRANSACTIONAL");
    filter.setTypeCondition(typeCondition);

    // Set the filter to request
    ListRequest request = new ListRequest();
    request.setFilter(filter);

    // Make call and print results
    printListResponse(service.list(request));
  }

  private void printListResponse(ListResponse response) throws Exception
  {
    List<ObjectId> mailingIds = response.getObjectId();

    System.out.println("\nList Response:");
    for (ObjectId each : mailingIds)
    {
      Mailing mailing = (Mailing)helper.get(each);
      System.out.println("\t" + each.getId() + " " + mailing.getName());
    }
  }

  public String getMailingStatus(MailingId mailingId) throws Exception
  {
    Mailing mailing = (Mailing)helper.get(mailingId);

    return mailing.getStatus();
  }

  public String waitForStatus(MailingId mailingId,
                                     String desiredStatus)
    throws Exception
  {
    String status;

    // Return immediately if desired status is received, or if any permanent
    // status is encountered.
    while (!(status = getMailingStatus(mailingId)).equals(desiredStatus) &&
           !status.equals("ERROR") &&
           !status.equals("FAILED") &&
           !status.equals("COMPLETED") &&
           !status.equals("CANCELED") &&
           !status.equals("SPEC_CANCELED") &&
           !status.equals("EDITING"))
    {
      System.out.println("waitForStatus on " + mailingId.getId() + ": " + status + "!=" + desiredStatus);
      Thread.sleep(10000);
    }
    System.out.println("waitForStatus on " + mailingId.getId() + " final: " + status +
                       (status.equals(desiredStatus) ? "==" : "!=") + desiredStatus);
    return status;
  }

  public boolean personalizeMailing(MailingId mailingId) throws InvalidObjectFault, UnexpectedFault, ObjectNotFoundFault, AuthorizationFault
  {
    PersonalizeMailingRequest request = new PersonalizeMailingRequest();

    request.setMailingId(mailingId);
    request.getMessageFormat().add("html");

    NameValuePair age = new NameValuePair();
    age.setName("userToken1");
    age.setValue("userTokenValue");

    NameValuePair name = new NameValuePair();
    name.setName("userTokenValue");
    name.setValue("Kedar");

    request.getPersonalizationTokens().add(name);
    request.getPersonalizationTokens().add(age);

    request.setUseMultiPart(false);
    PersonalizeResponse response = this.service.personalize(request);
    System.out.println(response.getPersonalizedMessage());

    return true;
  }

  private void addTagsToMailing(Mailing mailing)
  {
    try
    {
      TagFilter tagFilter = new TagFilter();

      ListRequest listRequest = new ListRequest();
      listRequest.setFilter(tagFilter);
      TagValueId tagValueId = null;

      ListResponse listResponse = service.list(listRequest);
      if(listResponse.getObjectId().size() > 0)
      {
        TagId tagId = (TagId) listResponse.getObjectId().get(0);
        GetRequest getRequest = new GetRequest();
        getRequest.getObjectId().add(tagId);
        Tag tag = (Tag)service.get(getRequest).getGetResponse().get(0).getBaseObject();
        tagValueId = tag.getTagValue().get(0).getTagValueId();
      }

      if(tagValueId != null)
      {
        // We can specify multiple tagValueIds. However, only one tag value can be assigned per tag.
        mailing.getTagValueId().add(tagValueId);
      }
    }
    catch(Exception e)
    {
      System.out.println("Exception occurred while adding tag in a mailing");
      e.printStackTrace();
    }
  }
}
