/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2014 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */

package com.strongmail.webserviceclient.samples.cxf;



import com.strongmail.webserviceclient.samples.cxf.generated.MailingService;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.*;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.DeleteRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.GetISFieldsRequest;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.InteractionField;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.InternalDataSource;
import com.strongmail.webserviceclient.samples.cxf.generated.objects.InternalDataSourceId;

import java.io.File;
import java.util.Calendar;
import java.util.List;


public class SamplesSelective
{
   public static void main(String... args) throws Exception
  {
    MailingService svc = SampleHelper.createService();
    SeedListSample seedListSample = new SeedListSample(svc);
    SuppressionListSample suppressionListSample = new SuppressionListSample(svc);
    TemplateSample templateSample = new TemplateSample(svc);
    MailingSample mailingSample =  new MailingSample(svc);

    String sequence = String.valueOf(System.currentTimeMillis());

    SeedListId seedListId = seedListSample.createSeedList("seed_cxf_"+sequence);
    seedListSample.getAndPrint(seedListId);

    SeedListId channelSeedListId = seedListSample.createChannelSeedList("channel_seed_cxf_"+sequence);
    seedListSample.getAndPrint(channelSeedListId);

    SuppressionListId supId = suppressionListSample.createSuppressionList("suppression_cxf" + sequence);
    suppressionListSample.getAndPrint(supId);

    SuppressionListId channelSupId = suppressionListSample.createChannelSuppressionList("channel_suppression_cxf" + sequence);
    suppressionListSample.getAndPrint(channelSupId);

    TemplateId templateId = templateSample.createTemplate("template_cxf_" + sequence);
    templateSample.getAndPrint(templateId);

    ChannelTemplateId channelTemplateId = templateSample.createChannelTemplate("channel_template_cxf_" + sequence);
    templateSample.getAndPrint(channelTemplateId);

    MailingId stdMailingId = mailingSample.createOneTimeStandardMailing("std_mailing_cxf_" + sequence);
    mailingSample.getAndPrint(stdMailingId);

    MailingId channelStdMailingId = mailingSample.createChannelStdMailing("channel_std_mailing_cxf_" + sequence);
    mailingSample.getAndPrint(channelStdMailingId);

    MailingId txMailingId = mailingSample.createTransactionalMailing("tx_mailing_cxf_" + sequence);
    mailingSample.getAndPrint(txMailingId);

    MailingId channelTxMailingId = mailingSample.createChannelTxMailing("channel_tx_mailing_cxf_" + sequence);
    mailingSample.getAndPrint(channelStdMailingId);

  }
}
